using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
	/// 数据访问类:T_Msg_NoticeInfo
	/// </summary>
	public partial class T_Msg_NoticeInfo
    {
        public T_Msg_NoticeInfo()
        { }
        #region  BasicMethod

        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Msg_NoticeInfo model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Msg_NoticeInfo(");
            strSql.Append("F_Title,F_Content,F_CreateOn,F_CreateBy,F_ModifyBy,F_ModifyDate,F_UserId,F_RoleId,F_isCus,F_isDel)");
            strSql.Append(" values (");
            strSql.Append("@F_Title,@F_Content,@F_CreateOn,@F_CreateBy,@F_ModifyBy,@F_ModifyDate,@F_UserId,@F_RoleId,@F_isCus,@F_isDel)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_Content", SqlDbType.NText),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
                    new SqlParameter("@F_ModifyBy", SqlDbType.Int,4),
                    new SqlParameter("@F_ModifyDate", SqlDbType.DateTime),
                    new SqlParameter("@F_UserId", SqlDbType.NVarChar,2000),
                    new SqlParameter("@F_RoleId", SqlDbType.NVarChar,2000),
                    new SqlParameter("@F_isCus", SqlDbType.Int,4),
                    new SqlParameter("@F_isDel", SqlDbType.Int,4),
            };
            parameters[0].Value = model.F_Title;
            parameters[1].Value = model.F_Content;
            parameters[2].Value = model.F_CreateOn;
            parameters[3].Value = model.F_CreateBy;
            parameters[4].Value = model.F_ModifyBy;
            parameters[5].Value = model.F_ModifyDate;
            parameters[6].Value = model.F_UserId;
            parameters[7].Value = model.F_RoleId;
            parameters[8].Value = model.F_isCus;
            parameters[9].Value = model.F_isDel;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Msg_NoticeInfo model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Msg_NoticeInfo set ");
            strSql.Append("F_Title=@F_Title,");
            strSql.Append("F_Content=@F_Content,");
            strSql.Append("F_CreateOn=@F_CreateOn,");
            strSql.Append("F_CreateBy=@F_CreateBy,");
            strSql.Append("F_ModifyBy=@F_ModifyBy,");
            strSql.Append("F_ModifyDate=@F_ModifyDate,");
            strSql.Append("F_UserId=@F_UserId,");
            strSql.Append("F_RoleId=@F_RoleId,");
            strSql.Append("F_isCus=@F_isCus,");
            strSql.Append("F_isDel=@F_isDel"); 
            strSql.Append(" where F_NoticeId=@F_NoticeId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_Content", SqlDbType.NText),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
                    new SqlParameter("@F_ModifyBy", SqlDbType.Int,4),
                    new SqlParameter("@F_ModifyDate", SqlDbType.DateTime),
                    new SqlParameter("@F_UserId", SqlDbType.NVarChar,2000),
                    new SqlParameter("@F_RoleId", SqlDbType.NVarChar,2000),
                    new SqlParameter("@F_isCus", SqlDbType.Int,4),
                    new SqlParameter("@F_isDel", SqlDbType.Int,4),
                    new SqlParameter("@F_NoticeId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_Title;
            parameters[1].Value = model.F_Content;
            parameters[2].Value = model.F_CreateOn;
            parameters[3].Value = model.F_CreateBy;
            parameters[4].Value = model.F_ModifyBy;
            parameters[5].Value = model.F_ModifyDate;
            parameters[6].Value = model.F_UserId;
            parameters[7].Value = model.F_RoleId;
            parameters[8].Value = model.F_isCus;
            parameters[9].Value = model.F_isDel;
            parameters[10].Value = model.F_NoticeId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_NoticeId)
        {

            StringBuilder strSql = new StringBuilder();
            //strSql.Append("delete from T_Msg_NoticeInfo ");
            strSql.Append("update T_Msg_NoticeInfo set F_isDel=1");
            strSql.Append(" where F_NoticeId=@F_NoticeId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_NoticeId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_NoticeId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_NoticeIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            //strSql.Append("delete from T_Msg_NoticeInfo ");
            strSql.Append("update T_Msg_NoticeInfo set F_isDel=1");
            strSql.Append(" where F_NoticeId in (" + F_NoticeIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Msg_NoticeInfo GetModel(int F_NoticeId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 * from T_Msg_NoticeInfo ");
            strSql.Append(" where F_NoticeId=@F_NoticeId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_NoticeId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_NoticeId;

            CallCenterApi.Model.T_Msg_NoticeInfo model = new CallCenterApi.Model.T_Msg_NoticeInfo();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Msg_NoticeInfo DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Msg_NoticeInfo model = new CallCenterApi.Model.T_Msg_NoticeInfo();
            if (row != null)
            {
                if (row["F_NoticeId"] != null && row["F_NoticeId"].ToString() != "")
                {
                    model.F_NoticeId = int.Parse(row["F_NoticeId"].ToString());
                }
                if (row["F_Title"] != null)
                {
                    model.F_Title = row["F_Title"].ToString();
                }
                if (row["F_Content"] != null)
                {
                    model.F_Content = row["F_Content"].ToString();
                }
                if (row["F_CreateOn"] != null && row["F_CreateOn"].ToString() != "")
                {
                    model.F_CreateOn = DateTime.Parse(row["F_CreateOn"].ToString());
                }
                if (row["F_CreateBy"] != null && row["F_CreateBy"].ToString() != "")
                {
                    model.F_CreateBy = int.Parse(row["F_CreateBy"].ToString());
                }
                if (row["F_ModifyBy"] != null && row["F_ModifyBy"].ToString() != "")
                {
                    model.F_ModifyBy = int.Parse(row["F_ModifyBy"].ToString());
                }
                if (row["F_ModifyDate"] != null && row["F_ModifyDate"].ToString() != "")
                {
                    model.F_ModifyDate = DateTime.Parse(row["F_ModifyDate"].ToString());
                }
                if (row["F_UserId"] != null)
                {
                    model.F_UserId = row["F_UserId"].ToString();
                }
                if (row["F_RoleId"] != null)
                {
                    model.F_RoleId = row["F_RoleId"].ToString();
                }
                if (row["F_isCus"] != null && row["F_isCus"].ToString() != "")
                {
                    model.F_isCus = int.Parse(row["F_isCus"].ToString());
                }
                if (row["F_isDel"] != null && row["F_isDel"].ToString() != "")
                {
                    model.F_isDel = int.Parse(row["F_isDel"].ToString());
                }

            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select * ");
            strSql.Append(" FROM T_Msg_NoticeInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" * ");
            strSql.Append(" FROM T_Msg_NoticeInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Msg_NoticeInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_NoticeId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Msg_NoticeInfo T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
